import * as ec2 from '@aws-cdk/aws-ec2';
import * as cdk from '@aws-cdk/core';
export interface RunnerManagerProps {
    /**
     * VPC for the fargate
     */
    readonly vpc: ec2.IVpc;
    /**
     * tags for the runner
     */
    readonly tags?: string[];
    /**
     * The security group for Fargate CI task
     */
    readonly securityGroup?: ec2.ISecurityGroup;
    /**
     * subnet for fargate CI task
     */
    readonly fargateJobSubnet?: ec2.SubnetSelection;
    /**
     * GitLab registration token for the runner
     */
    readonly registrationToken: string;
}
export declare class FargateRunner extends cdk.Construct {
    readonly vpc: ec2.IVpc;
    constructor(scope: cdk.Construct, id: string, props: RunnerManagerProps);
    private synthesizeTags;
    private createSecurityGroup;
}
